#include "Blog_MyAsset.h"
#include "AssetTypeActions_MyAsset.h"
#include "MyAsset.h"
#include "MyAssetEditor.h"

#define LOCTEXT_NAMESPACE "AssetTypeActions"

UClass* FAssetTypeActions_MyAsset::GetSupportedClass() const
{
	return UMyAsset::StaticClass();
}

void FAssetTypeActions_MyAsset::OpenAssetEditor(
	const TArray<UObject*>& InObjects,
	TSharedPtr<class IToolkitHost> EditWithinLevelEditor
	)
{
	for(int i = 0; i < InObjects.Num(); ++i)
	{
		FMyAssetEditor::CreateEditor(EToolkitMode::Standalone, EditWithinLevelEditor, InObjects[i]);
	}
}

void FAssetTypeActions_MyAsset::GetActions(const TArray<UObject*>& InObjects, FMenuBuilder& MenuBuilder)
{
	auto MyAssetImports = GetTypedWeakObjectPtrs<UMyAsset>(InObjects);
	MenuBuilder.AddMenuEntry(
		LOCTEXT("MyAsset_ZeroReset", "Zero Reset"),
		LOCTEXT("MyAsset_ZeroResetTooltip", "zero reset this MyAsset"),
		FSlateIcon(),
		FUIAction(
		FExecuteAction::CreateSP(this, &FAssetTypeActions_MyAsset::ExecuteZeroReset, MyAssetImports),
		FCanExecuteAction()
		)
	);
}
void FAssetTypeActions_MyAsset::ExecuteZeroReset(TArray<TWeakObjectPtr<class UMyAsset>> Objects)
{
	for(auto ObjIt = Objects.CreateIterator(); ObjIt; ++ObjIt)
	{
		auto Object = (*ObjIt).Get();
		if(Object)
		{
			Object->ValueA = Object->ValueB = Object->ValueC = 0;
			Object->MarkPackageDirty();
		}
	}
}

#undef LOCTEXT_NAMESPACE
